

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "baslib.h"

/*separac(char b[255],char s[1],char c[255],int pos,int nc);*/
/******************************************************************/
/* Decod_metar - Versão 2.8   CPTEC-INPE                          */ 
/*                                                                */
/*  Este Programa esta preparado para decodificar METAR /SPECI    */
/*  Em arquivos que contenha apenas este tipo de mensagens        */
/*    Caso haje outras mensagens misturadas, semelhantes ao METAR,*/
/*  erros eventuais de decodificacao poderam ocorrer              */	
/*                                                                */
/*     V2.0 - Sergio Ferreira  Original da Versao 2               */
/* ---------------------------------------------------------------*/
/*     V2.6  - Sergio Ferreira OUT 2002                           */
/*     V2.7  - Adaptacao da decodificacao da data e hora para     */
/*             formato do DCEA  - Sergio Ferreira 19/05/2004      */
/*     V2.8  - Mudanca do formato de entrada da tabela de estacoes*/
/*             Sergi Ferreira 26/05/2004                          */
/******************************************************************/

int nc; /*Global*/
char c[20][255],cteste[255],cteste2[255];
char icaod[255],icao1[5000][255],horad[255],hora1[5000][255];
int dup,itop;

/*******************************************************************/	
/* Carregar Arquivo de Codigo de Tempo Presente                    */
/*******************************************************************/
/* WWM,WW0, WW1 , WW2  -> Campos da Tabela() de Tempo Presente     */
/* wfim = Numero de elementos em WW0, WW1, WW2                     */
/*******************************************************************/ 
 int Tabela_ww_metar(char wwm[100][8],char ww0[100][6],int ww1[100],int ww2[100])
 {
 	int i,pos;
	char *res;
	char linha[255],arq[80];
	FILE *f5;
	if ((f5=fopen("Tabela_ww_metar.fnt","r"))==NULL){ 
	        fprintf(stderr,"\nError : Tabela_ww_metar.fnt doesn't exist\n\n");
		printf("\nError : %s doesn't exist\n\n",arq);
		exit(1);
		}/*end if*/
	  res=" ";	
	  i=0;
	  while ( res != NULL){
	        i=i+1;
                linha[0]= '\0';
	        res = fgets(linha,92,f5); 
		pos=separac2(linha,c);
		strcpy(&ww0[i][0],&c[1][0]);
		ww1[i]=atoi(&c[3][0]);
		ww2[i]=atoi(&c[4][0]);
		strcpy(&wwm[i][0],&c[2][0]);
		/*printf("%5s %8s %3d %3d\n",&ww0[i][0],&wwm[i][0],ww1[i],ww2[i]);*/
	  
	 }/*end while*/
	 fclose(f5);
	 return(i);
}/*End Tabela_ww_metar*/ 
/****************************************************************/
/**      Carregar Arquivo de Estacoes                          **/
/****************************************************************/
int Tabela_estacoes_metar(char estc[5000][6],char icac[5000][5],char latc[5000][7],char lonc[5000][7])
{
 char licao[255],lest[255],llat[255],llon[255],linha[255];
 char *res;
 FILE *f4; 
 int i;     
if ((f4=fopen("Tabela_estacoes_metar.txt","r"))==NULL){ 
	        fprintf(stderr,"\nError : Tabela_estacoes_metar.txt doesn't exist\n\n");
		exit(1);
		}/*end if*/
	i=0;
	res=" ";	
	while (res != NULL ){
	 i=i+1;
	 linha[0]='\0';
	 res = fgets(linha,92,f4);
	  
	  separac(linha,licao,2); 
	  separac(linha,lest,1);
	  separac(linha,llat,3);
	  separac(linha,llon,4);
	  strncpy(&estc[i][0],lest,5);
	  estc[i][5]='\0';
	  strncpy(&icac[i][0],licao,4);
	  icac[i][4]='\0';
	  strncpy(&latc[i][0],llat,6);
	  latc[i][6]='\0';
	  strncpy(&lonc[i][0],llon,6);
	  lonc[i][6]='\0';
	 /* printf("%s %s %s %s \n",lest,licao,llat,llon); */
	 }/*wend*/
	 
	 fclose(f4);
	 return(i);	
		
}
int duplic()
{
/* Verifica se existe um codigo icao duplicado */ 
 int i;
 dup = 0;
 for (i=0;i< itop;i++)
                     {
                    
		       
                       if ((strncmp(icaod,&icao1[i][0],4) == 0)&&(instr(horad,&hora1[i][0])>=0))
                         {
                          dup = 1;
                          break;
                         }
                     }
  if ((dup == 0)&&(itop<5000))
  {
    strncpy(&icao1[itop][0],icaod,4);
    strcpy(&hora1[itop][0],horad);
    
    itop=itop+1;                      
   }
 
}

/************************************************************/
/************************************************************/
/*****      Decod_METAR - PROGRAMA PRINCIPAL            *****/
/************************************************************/
/************************************************************/
void main(int argc,char *argv[])
{
	char b[255],s[255],arq[80],linha[255],aqf[80],arqestac[80];
	char *res,*rx,teste[1],icao[255],est[255],lat[255],lon[255];
        char estc[5000][6],icac[5000][5],lonc[5000][7],latc[5000][7];
	char iccao[4];
	int dia,ddia,mes,mesm,ano,anom,hora,min;
	
	char tt[3],td[3];       /* Temperatura e ponto de orvalho */
        char dir[3],vel[3];     /* direcao e velocidade do vento */
        char qq[5];            
        char anomesdia[11];     /*data do arquivo de mensagens METAR p/ decodificacao
                                 * Mensagens METAR que apresentarem datas futuras
                                 * a este data sao consideradas como o mesmo dia,
                                 * porem do mes anterior */
        
        char outform[6];       /*formato de saida dos dados 
                                * = gempak : format asc p/ uso no gempak */ 
	char amsul[255];
	char chk[255];
	
	int ww1[100],ww2[100],iww0,iww1,iww2;/* Variaveis Tempo Presente */
	char  wwm[100][8],ww0[100][6],wwest[8],ww0est[6];
	int wfim,iw,cavok,rmk;
	
	int visi,vismin,visstr; /*variaveis de Visibilidade */
	
	int NN,NCL,CL,HCL,HCLMIN,HTESTE,NTESTE; /*Variaveis de Nebulizidade */
	int pos,posf,idecod,cdecod[20];
	
	int l,i,j,k,instr(),separac2(),metardt,estct,metarct;
	char tipo[2];
	float vlat,vlon,vqq,vtt,vtd,vvel;
	float cterr;                                    /* numero de blocos com erros 							ou nao decodificados*/
	float ctcor;                                    /* Numero de blocos corretos */
	float conf; 					/* Confiabilidade ctcor/cterr */
	int vdir;
	FILE *f1,*f2,*f3,*f6;
/*********************************************************************/
        printf ("\n|---------------------------------------------------|");
	printf ("\n| decode_metar   2.8   AGO2002                      |");
	printf ("\n| INPE-CPTEC /SHF                                   |");
	printf ("\n|___________________________________________________|\n\n"); 
	if (argc < 4) 
        { 
    	 
        printf ("  Usage  infile outfile yyyymmdd [gempak] \n\n");
        exit(1);
        }
        
	
        strcpy (arq,argv[1]);
	printf ("Infile =  [%s] \n",arq);
	strcpy (aqf,argv[2]); 
	
	strcpy (anomesdia,argv[3]);
        
       
        outform[0]='\0';
        if (argc>=5) {strcpy (outform,argv[4]);}
        if (strcmp(&outform[0],"gempak")!=0){outform[0]='\0';}
	printf ("Outfile = [%s] [%s] \n",aqf,outform);
        
	ddia = midint(anomesdia,6,2);
	mes = midint(anomesdia,4,2);
	ano= midint (anomesdia,0,4);
	printf ("Date = [%4d-%2d-%2d] \n",ano,mes,ddia);
	
	
	
	
	
/*********************************************************************/	
/**    Carregar Arquivo de estacoes                                 **/
/*********************************************************************/
   estct=Tabela_estacoes_metar(estc,icac,latc,lonc);
   printf("> Tabela_estacoes_metar.fnt %d  Ok\n",estct);	

/*******************************************************************/	
/* Carregar Arquivo de Codigo de Tempo Presente                    */
/*******************************************************************/
/* WWM,WW0, WW1 , WW2  -> Campos da Tabela() de Tempo Presente     */
/* wfim = Numero de elementos em WW0, WW1, WW2                     */
/*******************************************************************/ 

   wfim=Tabela_ww_metar(wwm,ww0,ww1,ww2);	 
   printf("> Tabela_ww_metar.fnt %d  Ok\n",wfim);
   
/********************************************************************/
/**     Abri Arquivos                                               **/
/********************************************************************/	
	if ((f1=fopen(arq,"r"))==NULL){ 
	        fprintf(stderr,"\nError : %s doesn't exist\n\n",arq);
		printf("\nError : %s doesn't exist\n\n",arq);
		exit(1);
		}/*end if*/
	if ((f2=fopen(aqf,"w"))==NULL){ 
	        fprintf(stderr,"\nError : %s doesn't exist\n\n",aqf);
		exit(1);
		}/*end if*/
	if ((f3=fopen("dcm_trash.mtr","w"))==NULL){ 
	        fprintf(stderr,"\nError : dcm_trash.mtr doesn't exist\n\n");
		exit(1);
		}/*end if*/
	if ((f6=fopen("dcm_trash.txt","w"))==NULL){ 
	        fprintf(stderr,"\nError : dcm_trash.txt doesn't exist\n\n");
		exit(1);
		}/*end if*/			
  
       /* inicia arquivo de saida no caso de formato gempak */
       if(strcmp(&outform[0],"gempak")==0) {
       fprintf(f2,"STID YYYYMMDD/HHMM   ALTM  TMPC  DWPC DRCT  SPED WNUM CFRT \n");
       }

	res = " ";
	metarct=0;
	itop=0;	
/*******************************************************************/
/** Inicio da Leitura do Arquivo de Mensagem                      **/
/*******************************************************************/
	while ( res != NULL){
	
         linha[0]= '\0';
	 res = fgets(linha,92,f1); /* -----> Ler Uma Mensagem (Linha) */
	 
	 l=strlen(linha);
	 for(i=1;i<=l;i++){
	 if((linha[i]=='=')){
	  linha[i]='\0';
	  break;
	  
	 }
	
	}
	/*linha[l]='\0';*/ 
	 
	 posf=separac2(linha,c);
	
	
        
 	/* _________________________Inicia Variaveis da Decodificacao */
	
	
	s[1]=' ';
	nc=1;
	pos=0;
	idecod=0;
	strcpy(est,"00000");
	strcpy(lat,"999.99");
	strcpy(lon,"999.99");
	strcpy(dir,"999");
	strcpy(vel,"999.9");
	strcpy(tt,"999.9");
        strcpy(td,"999.9");
	strcpy(qq,"9999.9");
	dia=ddia;
	hora=0;
	min=0;
	strcpy(tipo,"M");
        vlat=999.99;
	vlon=999.99;
	vdir=999;
	vvel=999.9;
	vtt=999.9;
	vtd=999.9;
	vqq=9999.9;
	wwest[0]='\0';
	strcpy(wwest,"9999999");
	strcpy(ww0est,"99999");
	iww0=0;
	iww1=511;
	iww2=0; 
	iw=100;/* controle iw*/
	metardt=0;
	cavok=0;
	rmk=posf+1; /* Indica inicio do "remark". Se rmk=posf+1 nao ha remark */
	vismin=99999;
	visstr=9;
	visi=99999;
	NN=99;
	NCL=99;
	CL=99;
	HCL=99999;
	HCLMIN=99999;
	
	for(i=1;i<=20;i++){cdecod[i]=0;}
	/*____________________________________________________________*/
	/*___________________________________ Inicio da Decodificacao */
	
	
	while(pos<posf){
	pos=pos+1;
	
	if(pos<=2){
	
	strcpy(cteste,&c[pos][0]);
	if(strlen(cteste)==4){
	 i=0;
	 strcpy(icao,cteste);
	/*___________________________________________________________*/
	/*_____________________________Identificacao da Estacao [1] */
	while(i<estct){
	  i=i+1;
	  strcpy(chk,&icac[i][0]);	  
	  if(strcmp(&icac[i][0],&icao[0])==0){ 
	    /*printf("\n > %s %d",&estc[i][0],strlen(icao));*/
	    strcpy(est,&estc[i][0]);
	    strcpy(lat,&latc[i][0]);
	    strcpy(lon,&lonc[i][0]);
	    vlat=atof(lat);
	    vlon=atof(lon);
	    idecod=1; /*------->   estacao identificada */
	    cdecod[pos]=1; 
	    i=estct;
	   }/*endif*/
	 

	  }/*endwhile*/
	 }/*endif*/
	}/*endif*/
	/*__________________________________________________________*/
	/*__________________________Decodificacao de  Data Hora [2] */
	
	if((pos>=2)&&(pos<=4)&&(idecod==1)) {

	
	 strcpy(cteste,&c[pos][0]);
	 if (instr(cteste,"Z\0")==6) {
	   dia=midint(cteste,0,2);
	   hora=midint(cteste,2,2);
	   min=midint(cteste,4,2);
	 
	   
	   }/*end if*/
	   
	   
	   /**********************************************/
	   /* Identificacao de data hora sem o simbolo Z */
	   /** Rotina em faze de teste **/
	   /** Restricao dia=diad **/
	   /************************/
	   if ((cdecod[1]==1)&&(pos==2)){
	    if (strlen(cteste)==6){
	     dia=midint(cteste,0,2);
	     hora=midint(cteste,2,2);
	     min=midint(cteste,4,2);
	     mesm=mes;
	     anom=ano;
	     if (dia==ddia) { 
	    	   idecod=2;/* ------>  data/hora Identificada */ 
	           cdecod[pos]=2;
	     }/*enc if*/
	    }/*end if*/
	   }/*end if*/
	   
	
	   
	   if (instr(cteste,"Z\0")==4) {
	   hora=midint(cteste,0,2);
	   min=midint(cteste,2,2);
	   mesm=mes;
	   anom=ano;
	   idecod=2;/* ------>  data/hora Identificada */
	   cdecod[pos]=2;
	   strcpy(horad,cteste); 
	   
	   }/*end if*/
  
  
  
  
	   if (dia > ddia) { /* verificacao de mes anterior */ 
	     mesm=mes-1;
	     if (mesm<1){mesm=12;anom=ano-1;}else{anom=ano;}
	     }else{
	     mesm=mes;
	     anom=ano;
	   }/*end If dia */
	   strcpy(horad,cteste);
	   idecod=2;/* ------>  data/hora Identificada */ 
	   cdecod[pos]=2;
	   
	   
	   /* DATA E HORA FORMATO DO BANCO DO DCEA*/
	    if ((cdecod[1]==1)&&(pos==2)){
	    if (strlen(cteste)==12){
	     dia=midint(cteste,6,2);
	     hora=midint(cteste,8,2);
	     min=midint(cteste,10,2);
	     mesm=midint(cteste,4,2);
	     anom=midint(cteste,0,4);
	     if (dia==ddia) { 
	    	   idecod=2;/* ------>  data/hora Identificada */ 
	           cdecod[pos]=2;
	     }/*enc if*/
	    }/*end if*/
	   }/*end if*/
	      
	   	   
	   
        }/*end if*/

         
	
	/*____________________________________________________________*/
	/*__ Identificacao do remark[20]______________________________*/
	strcpy(cteste,&c[pos][0]);
	if ((pos>4)&&(pos<rmk)&&(instr(cteste,"RMK\0")>-1)&&(cdecod[pos]==0)){
	  cdecod[pos]=20;
	  rmk=pos;
	/*  printf("%s %d %d \n",cteste,cdecod[pos],pos);*/
	}/*end if*/
	
	
	if((pos>3)&&(pos<rmk)&&(cdecod[pos]==0)){
	/*__________________________________________________________ */
	/*___Decodificacao temperaturas do ar e ponto de orvalho [3] */
		
	
	strcpy(cteste,&c[pos][0]);
	k=instr(cteste,"/\0");
	if ((k>=2)&&(k<=3)&&(chkinstr(cteste,"0123456789M/\0")==1)){
	/*mid(cteste,cteste2,0,k);*/
	/*strcpy(cteste2,cteste);*/
	
	strncpy(tt,&cteste[0],k);tt[k]='\0';
	strncpy(td,&cteste[k+1],3);td[3]='\0';
	
	if (tt[0]=='M') tt[0]='-';
	if (td[0]=='M') td[0]='-';
	/*printf("\n %s \n",linha);*/
	if (chknum(tt)>0){
	  vtt=atof(tt);
	 }else{
	  vtt=999.9;

	 }/*end if chknum*/
	 
	if (chknum(td)>0){
	  vtd=atof(td);
	  if (vtd>vtt){ /* Verifica se Td > TT  e anula se for verdadeiro */
	   vtd=999.9;
	   vtt=999.9;
	   }
	 }else{
	  vtd=999.9;

	 }/*end if chknum*/
	if (((vtt < 60 )&&(vtt>-60))&&((vtd < 60 )&&(vtd>-60))){
	    cdecod[pos]=3;
	 }else{
	     vtt=999.9;
	     vtd=999.9;
	}
	
	
	
	
	}/*endif k=2 ...*/
	
	}/*endif pos > 3*/
	/*__________________________________________________________*/
	/*_________________________________Obter Pressao (QNH) [4]*/
	
	
	strcpy(cteste,&c[pos][0]);

	if ((pos>=3)&&(pos<rmk)&&((instr(cteste,"Q\0")==0)||(instr(cteste,"A\0")==0))){
	strncpy(qq,&cteste[1],4);
	qq[4]='\0';
	if (chknum(qq)>0){
	  vqq=atof(qq);
	  if(instr(cteste,"A\0")==0) { /* Converter Unidade de Polegada para Hpa*/
	  vqq=vqq*0.3386;
	  
	  }/*end if cteste=A*/
	
	  if (vqq>1300){ vqq=9999.9;}
	  if (vqq<850){vqq=9999.9;}
	  
	 }else{
	  vqq=9999.9;
          
	 }/*end if*/
	 
	 cdecod[pos]=4;
	}/*end if*/
	
	/*_______________________________________________________________*/
	/*_______________________Obter Direcao e Velocidade do Vento [5] */
	
	
	
	
	strcpy(cteste,&c[pos][0]);

	if ((pos>=2)&&(pos<rmk)&&(instr(cteste,"KT\0")>=5)){
	if ((instr(cteste,"KT\0")==5)||(instr(cteste,"G\0")==5)){
	/*left(c,dir,3);*/
	strncpy(dir,&cteste[0],3);
	strncpy(vel,&cteste[3],2);
	vel[2]='\0';
	dir[3]='\0';
	
	if (chknum(vel)>0){
	  vvel=atof(vel);
	 }else{
	  vvel=999.9;
	  vdir=999;
	 }/*end if*/
	 
	if (chknum(dir)>0){
	  vdir=atof(dir);
	 }else{
	  vvel=999.9;
	  vdir=999;
	 }/*end if*/
	 cdecod[pos]=5;
	 /*______________Tratamento dados de Rajada*/
	 /*________*/
	 }/*endif*/
	}/*endif*/
	/*___________________________________________________________*/
	/* ________________________________________________CAVOK [10]*/
	/*if (metardt=1){*/
	
	 if ((pos>=3)&&(pos<rmk)&&(instr(cteste,"CAVOK\0")>-1)){cavok=1;cdecod[pos]=10;} 
	 if (instr(cteste,"SPECI\0")>-1){cdecod[pos]=10;strcpy(tipo,"S");}
	 if (instr(cteste,"METAR\0")>-1){cdecod[pos]=10;}
	   
	/*}/*end if*/ 
	
	  
	}/*wend*/
	
	/*__________________________________________________________________*/
	/*__________________________Teste de Validacao da Mensagem          */
	/* Esta parte trata das condicoes minimas para que  mensagens sejam */
	/* aceitas ou rejeitadas. Sao aceitas apenas as mensagens que       */
	/* apresentam:                                                      */   
	/*  Numero de estacao cadastrado                                    */
	/*  Data e hora corretamente codificacod                            */
	/*  pressao e/ou vento codificados corretamente                     */
	/*                                                                  */
	/* A mensagem aceita nesta parte pode ser rejeitadas posteriormente */
	/* em outros seguimentos do programa                                */ 
	/*                                                                  */
	/********************************************************************/
	metardt=0;
	if (idecod==2){
	if ((vqq<1300)||(vdir<=360)){
	  metardt=1;
	}/*end if*/
	}/*end if*/
	
	
	
	/*__________________________________________________________*/
	/* ________________Indicadores de Tendencia (previsao )     */
	/* Eliminacao da verificacao das previsoes do Metar         */
	
	if (metardt==1) {
	 for (pos=3;pos<=posf;pos++){
	  strcpy(cteste,&c[pos][0]);
	  if(instr(cteste,"TEMPO\0")>-1){posf=pos-1;}
	  if(instr(cteste,"BECMG\0")>-1){posf=pos-1;}
	  if(instr(cteste,"NOSIG\0")>-1){posf=pos-1;}
	  rmk=posf+1;
	 }/*end for */
	}/*end if */
	/*************************************************************/
	/*  Segunda Parte da Decodificacao                           */
	/*___________________________________________________________*/
	/* detecao do RVR [50]*/
	for (pos=3;pos<=posf;pos++){
	if (cdecod[pos]==0){
	strcpy(cteste,&c[pos][0]);
	if ((instr(cteste,"R\0")==0)&&(instr(cteste,"/\0")>0)){
	cdecod[pos]=50;
	}/*end if instr*/
	}/*end cdecod */
	}/*end for */

	/*_____________________________________Tempo Presente [6]*/
	if (metardt==1){
	if (cavok==0) {
	
	 for (pos=3;pos<=rmk;pos++){
	 if ((cdecod[pos]==0)||(cdecod[pos]==6)){
	  i=-1;
	  
	  strcpy(cteste,&c[pos][0]);
	  if (strlen(cteste)<=6){
	  for (j=1;j<=wfim;j++){
	  
	  i=instr(cteste,&wwm[j][0]);
	  if ((i>-1)&&(iw>i)){
	  
	   iw=i;
	  
	  /* strcpy(wwest,cteste);*/
	   strcpy(wwest,&wwm[j][0]);
	   strcpy(ww0est,&ww0[j][0]);
	   if(iw>0){
	   /*  strcat(wwest,"!"); */
	     ww0est[0]='0';
	   }
	   iww0=atoi(ww0est);
	   iww1=ww1[j];
	   iww2=ww2[j];
	   cdecod[pos]=6;
	  
	   }/*end if i>-1*/
	  }/*next*/
	  /*if (iw<100){printf("%s\n%s %s\n",linha,cteste,wwest);} */
	  }/*end if len(cteste)<=6*/
	  }/*end if cdeco!=0*/
	  }/*next pos*/
	  
	 
	 
	 /*___________________________________________________________*/
	 /*_______________________________________VISIBiLIDADE [7]*/
	 for (pos=3;pos<=rmk;pos++){
	 if ((cdecod[pos]==0)||((cdecod[pos]==7))&&(iww0>0)){

	   strcpy(cteste,&c[pos][0]);
	   if (chkinstr(cteste,"0123456789NESW\0")==1){ 
	   
	   if ((strlen(cteste)==4)&&(chknum(cteste)==1)){
	    visi=atoi(cteste);
	    if (visi==9999){visi=10000;}
	    cdecod[pos]=7;
	/*    if (iww0==0){printf("Tempo Presente Omitido !\n");}*/
	
	    if ((vismin>visi)&&(visi>=0)){vismin=visi,visstr=0;}
	   }else{
	   if(strlen(cteste)>=5){
	    mid (cteste,cteste2,0,4);
	   
	    if (chknum(cteste2)==1){
	     
	       visi=atoi(cteste2);
	       if ((vismin>visi)&&(visi>=0)){
	      
	       if(instr(cteste,"N\0")==4){visstr=1;vismin=visi;cdecod[pos]=7;}
	       if(instr(cteste,"E\0")==4) {visstr=3;vismin=visi;cdecod[pos]=7;}
	       if(instr(cteste,"S\0")==4) {visstr=5;vismin=visi;cdecod[pos]=7;}
	       if(instr(cteste,"W\0")==4) {visstr=7;vismin=visi;cdecod[pos]=7;}
	       if(instr(cteste,"NE\0")==4) {visstr=2;vismin=visi;cdecod[pos]=7;}
	       if(instr(cteste,"SE\0")==4) {visstr=4;vismin=visi;cdecod[pos]=7;}
	       if(instr(cteste,"SW\0")==4) {visstr=6;vismin=visi;cdecod[pos]=7;}
	       if(instr(cteste,"NW\0")==4) {visstr=8;vismin=visi;cdecod[pos]=7;}
	       
	       }/*end if */
	       
	     }/*end if*/ 
	   }/*end if */
	     
	   }/*end if strlen(cteste)==4*/
	  }/*end if chkinstr */
	   
	 }/*end if cdecod==0*/
	 }/*next pos*/
	 /*_____________________________________________________*/
	 /*____________________________Nebulosidade [8]*/
	 
	 for (pos=3;pos<=rmk;pos++){
	   if (cdecod[pos]==0){
	    i=0;
	    j=-1;
	   
	    strcpy(cteste,&c[pos][0]);
            if(instr(cteste,"FEW\0")>-1){i=2;j=instr(cteste,"FEW\0");}
	    if(instr(cteste,"SCT\0")>-1){i=4;j=instr(cteste,"SCT\0");}
	    if(instr(cteste,"BKN\0")>-1){i=7;j=instr(cteste,"BKN\0");}
	    if(instr(cteste,"OVC\0")>-1){i=8;j=instr(cteste,"OVC\0");}
	    if((i==2)&&((NN<2)||(NN=99))){NN=2;cdecod[pos]=8;}
	    if((i==4)&&((NN<4)||(NN=99))){NN=4;cdecod[pos]=8;}
	    if((i==7)&&((NN<6)||(NN=99))){NN=7;cdecod[pos]=8;}
	    if((i==8)&&((NN<7)||(NN=99))){NN=8;cdecod[pos]=8;}
	    
	    if ((i>0)&& (CL==99)) { 
	             strncpy(s,&cteste[j+3],3);
	             HTESTE=atoi(s)*30;
		     if (HTESTE<HCL){HCL=HTESTE;NCL=i;}
		     }/*END IF */
	    if (instr(cteste,"CB\0")>-1){       /*Verifica a Presenca de CB */
	      
	      if (i>0){
	      CL=9;NCL=i;cdecod[pos]=8;
	      strncpy(s,&cteste[j+3],3);
	      HCL=atoi(s)*30;
	      }/*end if*/
	    }/*end if CB*/
          if ((instr(cteste,"TCU\0")>-1)&&(CL==99)){/*Verifica a Presenca de TCU */
	     
	      if (i>0){
	      CL=2;NCL=i;cdecod[pos]=8;
	      strncpy(s,&cteste[j+3],3);
	      HCL=atoi(s)*30;
	      }/*end if*/
	     }/*endif TCU*/
	    if ((NN!=99)&&(instr(ww0est,"99999\0")>-1)){
	     /*wwest[0]='\0';*/
	    }/*end if*/
	   }/*end if cdecod */
	   
	 }/*next pos*/
	 /*______________________________________________*/
	 }else{/* cavok  !=0*/
	  strcpy(wwest,"CAVOK");
	  vismin=10000;visstr=0;
	  iww0=0;iww1=100;iww2=0;
	  NCL=0;CL=0;NN=99;HCL=99999;
	  /*NN=99;
	  NCL=99;
	  CL=99;
	  HCL=99999;*/
	  strcpy(ww0est,"00000");
	  }/*end if cavok*/
	  
	  /*______________________________________________*/
	  /* Verificacao de tempo Presente nao significativo */
	  
	  if(instr(ww0est,"99999\0")==0){
	    if ((vismin>=10000)&&(HCL<1500)){
	      strcpy(ww0est,"00000");
	      iww1=100;
	      iww2=0;
	      vismin=10000;
	       wwest[0]='\0';
	      }/*end if */
	    }/*end if*/
	  }/*end if matardt !=0*/
	  
	  
	  
	 /**********************************************************/
	 /* Verificar numero de erros encontrados do inicio ate RMK*/
	 /*  Se houver mais de 50% erros a mensagem sera rejeitada */
	 /**********************************************************/
	  cterr=0;  /* Numero de blocos com erros */
	  ctcor=0;    /* Numero de blocos coretos */
	  for (pos=1;pos<=rmk;pos++){
	   if (cdecod[pos]==0){
	     cterr=cterr+1;
	   }else{
	     ctcor=ctcor+1;
	   }/*end if*/
	  }/*end for*/
	  conf=ctcor/(cterr+ctcor);
	 /* printf("%f\n",conf);*/
	  if(conf<0.5){metardt=0;}
	  
	/************************************************************/
	/*     FIM DA DECODIFICACAO de CADA MENSAGEM                */
	/************************************************************/
	
	/*******************************/
	/* Imprimir metar decodificado */
	/*******************************/
	
	if (metardt==1){
	/*__________________________________________________________*/
     
	 
       
        strncpy(icaod,icao,4);
        duplic();
	 if (vlat<900 && dup==0) {
         
         if (strcmp(&outform[0],"gempak")!=0){ /*Imprimir formato padrao */
	    
             fprintf(f2,"%4s %5s%7.2f%7.2f",icao,est,vlat,vlon);
             fprintf(f2," %4d-%02d-%02d  %02d:%02d",anom,mesm,dia,hora,min);
             fprintf(f2," %6.1f%5.1f%5.1f %3d%5.1f %7s",vqq,vtt,vtd,vdir,vvel,wwest);
	     fprintf(f2,"%5s%3d%3d",ww0est,iww1,iww2); 
             fprintf(f2,"%5d-%1d %2d%2d%2d%5d%1s|",vismin,visstr,NN,NCL,CL,HCL,tipo);
            
	 for (pos=1;pos<=posf;pos++){
	  
          if (cdecod[pos]>10){
	    strcpy(cteste,&c[pos][0]);
	    if (chkcrt(cteste)==0){fprintf(f2,"%s ",&c[pos][0]);}
	  
          }/*end if*/
	  
          if (cdecod[pos]==0){
	  
            strcpy(cteste,&c[pos][0]);
	    if (chkcrt(cteste)==0){fprintf(f2,"<%s>",&c[pos][0]);}
	  
          }/*end if*/
	 
         }/*end for*/
	 
         }else{ /* formato gempak */
             fprintf(f2,"%4s",icao);
             fprintf(f2," %4d%02d%02d/%02d%02d",anom,mesm,dia,hora,min);
             fprintf(f2," %6.1f %5.1f %5.1f  %3d %5.1f",vqq,vtt,vtd,vdir,vvel);
             
            if( NN != 99){
                fprintf(f2,"   00 %2d",NN);
                }else {
                fprintf(f2,"   00  -");
             }
     

         }/*end imprimir formato padrao*/
         
          fprintf(f2,"\n");
          metarct=metarct+1;
	 
          }else{
	  if (dup==0) {
	  fprintf(f3,"%4s %5s%7.2f%7.2f %4d-%02d-%02d  %02d:%02d %6.1f%5.1f%5.1f %3d%5.1f %7s",icao,est,vlat,vlon,anom,mesm,dia,hora,min,vqq,vtt,vtd,vdir,vvel,wwest);
	  fprintf(f3,"%5s%3d%3d %5d-%1d %2d%2d%2d%5d%1s\n",ww0est,iww1,iww2,vismin,visstr,NN,NCL,CL,HCL,tipo);
	   }
	 }/*endif vlat*/
	 }else{
	   fprintf(f6,"\n");
	/*   for (pos=1;pos<=posf;pos++){
	     fprintf(f6," %2d",cdecod[pos]);
	   }
	   if (posf<15){
	    for(pos=posf;pos<=16;pos++){
	     fprintf(f6,"   ");
	    }
	   }
	   
	   fprintf(f6,"|");*/
	   for (pos=1;pos<=posf;pos++){
	    fprintf(f6," %s",&c[pos][0]); 
	   }/*end for*/
	   
	}/*endif metardt*/
	
	
	}/*wend res*/
	fclose(f1);
	fclose(f2);
	fclose(f3);
	fclose(f6);
	printf("\n> %d Metar decoded \n\n",metarct);
}/* end main */

